import { ContentfulCache, ContentfulClient } from 'react-contentful';
var client = null;

function create(_ref) {
  var accessToken = _ref.accessToken,
      cache = _ref.cache,
      host = _ref.host,
      space = _ref.space,
      _ref$environment = _ref.environment,
      environment = _ref$environment === void 0 ? 'master' : _ref$environment;
  return new ContentfulClient({
    host: host,
    accessToken: accessToken,
    space: space,
    environment: environment,
    ssrMode: !!process.browser === false,
    cache: cache instanceof ContentfulCache ? cache : new ContentfulCache().restore(cache)
  });
}

export default function initContentful(initialState) {
  if (initialState === void 0) {
    initialState = {};
  }

  if (!process.browser) {
    return create(initialState);
  }

  if (!client) {
    client = create(initialState);
  }

  return client;
}