import _regeneratorRuntime from "@babel/runtime/regenerator";
import _extends from "@babel/runtime/helpers/extends";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import Head from 'next/head';
import { getDataFromTree } from 'next-utils';
import { ContentfulProvider } from 'react-contentful';
import { getDisplayName } from 'react-hoc-helpers';
import { stringify } from 'flatted';
import initContentful from './initContentful';
export default function withContentful(_ref) {
  var accessToken = _ref.accessToken,
      host = _ref.host,
      space = _ref.space,
      environment = _ref.environment,
      locale = _ref.locale;
  return function (ComposedComponent) {
    var _class, _temp;

    var propTypes = {
      contentfulState: PropTypes.shape()
    };
    var defaultProps = {
      contentfulState: null
    };
    var Contentful = (_temp = _class = /*#__PURE__*/function (_React$Component) {
      _inheritsLoose(Contentful, _React$Component);

      function Contentful(props) {
        var _this;

        _this = _React$Component.call(this, props) || this;
        _this.contentfulClient = initContentful(props.contentfulState);
        return _this;
      }

      Contentful.getInitialProps = /*#__PURE__*/function () {
        var _getInitialProps = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(props) {
          var Component, router, ctx, composedInitialProps, contentful, contentfulState;
          return _regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  Component = props.Component, router = props.router, ctx = props.ctx;
                  composedInitialProps = {};

                  if (!ComposedComponent.getInitialProps) {
                    _context.next = 6;
                    break;
                  }

                  _context.next = 5;
                  return ComposedComponent.getInitialProps(props);

                case 5:
                  composedInitialProps = _context.sent;

                case 6:
                  // Run all Contentful queries in the component tree
                  // and extract the resulting data
                  contentful = initContentful({
                    accessToken: accessToken,
                    host: host,
                    space: space,
                    environment: environment
                  });

                  if (process.browser) {
                    _context.next = 17;
                    break;
                  }

                  _context.prev = 8;
                  _context.next = 11;
                  return getDataFromTree( /*#__PURE__*/React.createElement(ContentfulProvider, {
                    client: contentful,
                    locale: locale
                  }, /*#__PURE__*/React.createElement(ComposedComponent, _extends({
                    Component: Component,
                    ctx: ctx,
                    router: router,
                    store: ctx.store
                  }, composedInitialProps))));

                case 11:
                  _context.next = 16;
                  break;

                case 13:
                  _context.prev = 13;
                  _context.t0 = _context["catch"](8);

                  // Prevent Contentful Client errors from crashing SSR.
                  // Handle them in components via the data.error prop:
                  if (process.env.NODE_ENV === 'development') {
                    console.log(_context.t0);
                  }

                case 16:
                  // getDataFromTree does not call componentWillUnmount
                  // head side effect therefore need to be cleared manually
                  Head.rewind();

                case 17:
                  // Pass in the Contentful client credentials and initial cache state
                  contentfulState = {
                    accessToken: accessToken,
                    host: host,
                    space: space,
                    environment: environment,
                    cache: stringify(contentful.cache.extract())
                  };
                  return _context.abrupt("return", _objectSpread(_objectSpread({}, composedInitialProps), {}, {
                    contentfulState: contentfulState
                  }));

                case 19:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, null, [[8, 13]]);
        }));

        function getInitialProps(_x) {
          return _getInitialProps.apply(this, arguments);
        }

        return getInitialProps;
      }();

      var _proto = Contentful.prototype;

      _proto.render = function render() {
        return /*#__PURE__*/React.createElement(ContentfulProvider, {
          client: this.contentfulClient,
          locale: locale
        }, /*#__PURE__*/React.createElement(ComposedComponent, this.props));
      };

      return Contentful;
    }(React.Component), _defineProperty(_class, "displayName", "withContentful(" + getDisplayName(ComposedComponent) + ")"), _temp);
    Contentful.propTypes = propTypes;
    Contentful.defaultProps = defaultProps;
    return Contentful;
  };
}