"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = withContentful;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _head = _interopRequireDefault(require("next/head"));

var _nextUtils = require("next-utils");

var _reactContentful = require("react-contentful");

var _reactHocHelpers = require("react-hoc-helpers");

var _flatted = require("flatted");

var _initContentful = _interopRequireDefault(require("./initContentful"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function withContentful(_ref) {
  var accessToken = _ref.accessToken,
      host = _ref.host,
      space = _ref.space,
      environment = _ref.environment,
      locale = _ref.locale;
  return function (ComposedComponent) {
    var _class, _temp;

    var propTypes = {
      contentfulState: _propTypes["default"].shape()
    };
    var defaultProps = {
      contentfulState: null
    };
    var Contentful = (_temp = _class = /*#__PURE__*/function (_React$Component) {
      (0, _inheritsLoose2["default"])(Contentful, _React$Component);

      function Contentful(props) {
        var _this;

        _this = _React$Component.call(this, props) || this;
        _this.contentfulClient = (0, _initContentful["default"])(props.contentfulState);
        return _this;
      }

      Contentful.getInitialProps = /*#__PURE__*/function () {
        var _getInitialProps = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(props) {
          var Component, router, ctx, composedInitialProps, contentful, contentfulState;
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  Component = props.Component, router = props.router, ctx = props.ctx;
                  composedInitialProps = {};

                  if (!ComposedComponent.getInitialProps) {
                    _context.next = 6;
                    break;
                  }

                  _context.next = 5;
                  return ComposedComponent.getInitialProps(props);

                case 5:
                  composedInitialProps = _context.sent;

                case 6:
                  // Run all Contentful queries in the component tree
                  // and extract the resulting data
                  contentful = (0, _initContentful["default"])({
                    accessToken: accessToken,
                    host: host,
                    space: space,
                    environment: environment
                  });

                  if (process.browser) {
                    _context.next = 17;
                    break;
                  }

                  _context.prev = 8;
                  _context.next = 11;
                  return (0, _nextUtils.getDataFromTree)( /*#__PURE__*/_react["default"].createElement(_reactContentful.ContentfulProvider, {
                    client: contentful,
                    locale: locale
                  }, /*#__PURE__*/_react["default"].createElement(ComposedComponent, (0, _extends2["default"])({
                    Component: Component,
                    ctx: ctx,
                    router: router,
                    store: ctx.store
                  }, composedInitialProps))));

                case 11:
                  _context.next = 16;
                  break;

                case 13:
                  _context.prev = 13;
                  _context.t0 = _context["catch"](8);

                  // Prevent Contentful Client errors from crashing SSR.
                  // Handle them in components via the data.error prop:
                  if (process.env.NODE_ENV === 'development') {
                    console.log(_context.t0);
                  }

                case 16:
                  // getDataFromTree does not call componentWillUnmount
                  // head side effect therefore need to be cleared manually
                  _head["default"].rewind();

                case 17:
                  // Pass in the Contentful client credentials and initial cache state
                  contentfulState = {
                    accessToken: accessToken,
                    host: host,
                    space: space,
                    environment: environment,
                    cache: (0, _flatted.stringify)(contentful.cache.extract())
                  };
                  return _context.abrupt("return", _objectSpread(_objectSpread({}, composedInitialProps), {}, {
                    contentfulState: contentfulState
                  }));

                case 19:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, null, [[8, 13]]);
        }));

        function getInitialProps(_x) {
          return _getInitialProps.apply(this, arguments);
        }

        return getInitialProps;
      }();

      var _proto = Contentful.prototype;

      _proto.render = function render() {
        return /*#__PURE__*/_react["default"].createElement(_reactContentful.ContentfulProvider, {
          client: this.contentfulClient,
          locale: locale
        }, /*#__PURE__*/_react["default"].createElement(ComposedComponent, this.props));
      };

      return Contentful;
    }(_react["default"].Component), (0, _defineProperty2["default"])(_class, "displayName", "withContentful(" + (0, _reactHocHelpers.getDisplayName)(ComposedComponent) + ")"), _temp);
    Contentful.propTypes = propTypes;
    Contentful.defaultProps = defaultProps;
    return Contentful;
  };
}